## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_with debug

Name: gtengine
Summary: Library for computations in mathematics, graphics, image analysis, and physics
Version: 7.2
Release: %autorelease
Epoch: 1
# Automatically converted from old format: Boost - review is highly recommended.
License: BSL-1.0
URL: http://www.geometrictools.com
Source0: https://github.com/davideberly/GeometricTools/archive/GTE-version-%{version}/GeometricTools-GTE-version-%{version}.tar.gz

BuildRequires: pkgconfig(gl)
BuildRequires: pkgconfig(xext)
BuildRequires: pkgconfig(x11)
BuildRequires: pkgconfig(libpng)
BuildRequires: pkgconfig(egl)
BuildRequires: glibc-devel
BuildRequires: gcc-c++
BuildRequires: gcc
BuildRequires: cmake
BuildRequires: dos2unix
BuildRequires: libstdc++-devel
BuildRequires: make

%description
A library of source code for computing in the fields of mathematics,
graphics, image analysis, and physics.
The engine is written in C++ 11 and, as such, has portable access
to standard constructs for multithreading programming on cores.
The engine also supports high-performance computing using general
purpose GPU programming (GPGPU).
SIMD code is also available using Intel Streaming SIMD Extensions (SSE).

GTEngine requires OpenGL 4.5.0 (or later).

%package devel
Summary: Development files for %{name}
Requires: %{name}%{?_isa} = 1:%{version}-%{release}
%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package samples
Summary: Samples files of %{name}
Requires: %{name}%{?_isa} = 1:%{version}-%{release}
%description samples
This package contains samples files for
testing that use %{name}.

%prep
%autosetup -n GeometricTools-GTE-version-%{version}

# Remove -Werror flags (rhbz#1923590)
find . -type f \( -name "CMakeLists.txt" \) -exec sed -i 's| -Werror||g' '{}' \;

sed -i 's|GTE_VERSION_MINOR 1|GTE_VERSION_MINOR 2|g' -i GTE/CMakeLists.txt

%build

%if %{with debug}
%cmake -S GTE -DCMAKE_BUILD_TYPE:STRING=Debug -DBUILD_RELEASE_LIB:BOOL=ON -DBUILD_SHARED_LIB:BOOL=ON
%else
%cmake -S GTE -DCMAKE_BUILD_TYPE:STRING=Release -DBUILD_RELEASE_LIB:BOOL=ON -DBUILD_SHARED_LIB:BOOL=ON
%endif
%cmake_build

pushd GTE
%if %{with debug}
%cmake -S Samples -DCMAKE_SKIP_RPATH:BOOL=ON -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON -DCMAKE_BUILD_TYPE:STRING=Debug \
 -DBUILD_RELEASE_LIB:BOOL=ON -DBUILD_SHARED_LIB:BOOL=ON
%else
%cmake -S Samples -DCMAKE_SKIP_RPATH:BOOL=ON -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON -DCMAKE_BUILD_TYPE:STRING=Release \
 -DBUILD_RELEASE_LIB:BOOL=ON -DBUILD_SHARED_LIB:BOOL=ON
%endif
%cmake_build
popd

%install
echo 'Manual installation...'

mkdir -p $RPM_BUILD_ROOT%{_libdir}/pkgconfig
install -pm 755 GTE/lib/ReleaseShared/* $RPM_BUILD_ROOT%{_libdir}/

ln -sf libgtapplications.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libgtapplications.so
ln -sf libgtgraphics.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libgtgraphics.so
ln -sf libgtmathematicsgpu.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libgtmathematicsgpu.so
ln -sf libgtapplications.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libgtapplications.so.7
ln -sf libgtgraphics.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libgtgraphics.so.7
ln -sf libgtmathematicsgpu.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libgtmathematicsgpu.so.7

mkdir -p $RPM_BUILD_ROOT%{_includedir}/GTE
cp -a GTE/Applications $RPM_BUILD_ROOT%{_includedir}/GTE/
cp -a GTE/Graphics $RPM_BUILD_ROOT%{_includedir}/GTE/
cp -a GTE/Mathematics $RPM_BUILD_ROOT%{_includedir}/GTE/
find $RPM_BUILD_ROOT%{_includedir}/GTE -type f -name "*.cpp" -exec rm -f '{}' \;

mkdir -p $RPM_BUILD_ROOT%{_includedir}/GTL
cp -a GTL/Mathematics $RPM_BUILD_ROOT%{_includedir}/GTL/
cp -a GTL/Utility $RPM_BUILD_ROOT%{_includedir}/GTL/
find $RPM_BUILD_ROOT%{_includedir}/GTL -type f -name "*.vcxproj" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_includedir}/GTL -type f -name "*.sln" -exec rm -f '{}' \;

## Install GTL files
mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/%{name}
cp -a GTE/Samples $RPM_BUILD_ROOT%{_libexecdir}/%{name}/

# Remove unused files
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.h" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.cpp" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.filters" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.vcxproj" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.csproj" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.sln" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.gte" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.o" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "cmake*" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "CMake*" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "Makefile" -exec rm -f '{}' \;
find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type f -name "*.json" -exec rm -f '{}' \;

for i in `find $RPM_BUILD_ROOT%{_libexecdir}/%{name}/Samples -type d -name "CMakeFiles"`; do
 rm -rf $i
done
##

# Edit a pkg-config file
cat > $RPM_BUILD_ROOT%{_libdir}/pkgconfig/gtengine.pc <<EOF
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_includedir}

xthreadlib=-lpthread

Name: GTEngine
Description: Library for computations in mathematics, graphics, image analysis, and physics
Version: %{version}
Cflags: -I%{_includedir}/GTE -I%{_includedir}/GTL
Libs: -lgtgraphics -lgtmathematicsgpu -lgtapplications
Libs.private: -lpthread
EOF

%files
%license LICENSE
%doc README.md
%{_libdir}/libgt*.so.%{version}
%{_libdir}/libgt*.so.7

%files devel
%{_includedir}/GTE/
%{_includedir}/GTL/
%{_libdir}/libgt*.so
%{_libdir}/pkgconfig/gtengine.pc

%files samples
%doc GTE/*InstallationRelease.pdf GTL/Documentation/GTLUtility.pdf
%{_libexecdir}/%{name}/

%changelog
## START: Generated by rpmautospec
* Sat Jan 25 2025 Antonio Trande <sagitter@fedoraproject.org> - 1:7.2-1
- Release 7.2

* Fri Jan 17 2025 Fedora Release Engineering <releng@fedoraproject.org> - 1:7.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Sun Aug 04 2024 Antonio Trande <sagitter@fedoraproject.org> - 1:7.1-2
- Release 7.1|Fix library version

* Sun Aug 04 2024 Antonio Trande <sagitter@fedoraproject.org> - 1:7.1-1
- Release 7.1

* Wed Jul 24 2024 Miroslav Suchý <msuchy@redhat.com> - 1:6.6-6
- convert Boost license to SPDX

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:6.6-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:6.6-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sat Jan 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1:6.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1:6.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jun 17 2023 Antonio Trande <sagitter@fedoraproject.org> - 1:6.6-1
- Release 6.6

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1:6.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1:6.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sun Jul 10 2022 Antonio Trande <sagitter@fedoraproject.org> - 1:6.4-1
- Release 6.4

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1:5.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Sep 03 2021 Antonio Trande <sagitter@fedoraproject.org> - 1:5.12-1
- Release 5.12

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1:5.10-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon Jun 14 2021 Antonio Trande <sagitter@fedoraproject.org> - 1:5.10-2
- Release 5.10| Fix documentation

* Mon Jun 14 2021 Antonio Trande <sagitter@fedoraproject.org> - 1:5.10-1
- Release 5.10

* Wed May 05 2021 Antonio Trande <sagitter@fedoraproject.org> - 1:5.9-3
- Release 5.9| Fix main directory name

* Wed May 05 2021 Antonio Trande <sagitter@fedoraproject.org> - 1:5.9-2
- Release 5.9| New source code archive

* Wed May 05 2021 Antonio Trande <sagitter@fedoraproject.org> - 1:5.9-1
- Release 5.9

* Mon Feb 15 2021 Antonio T <sagitter@fedoraproject.org> - 1:5.6-3
- Symlinks versioned libraries

* Mon Feb 15 2021 Antonio T <sagitter@fedoraproject.org> - 1:5.6-2
- Remove -Werror flags (rhbz#1923590)

* Sat Feb 13 2021 Antonio T <sagitter@fedoraproject.org> - 1:5.6-1
- Release 5.6

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1:5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sat Dec 19 2020 Tom Stellard <tstellar@redhat.com> - 1:5.1-2
- Add BuildRequires: make

* Sun Oct 11 2020 sagitter <sagitter@fedoraproject.org> - 1:5.1-1
- Release 5.1| Switch to CMake build method

* Wed Sep 16 2020 sagitter <sagitter@fedoraproject.org> - 1:5.0-1
- Release 5.0

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1:4.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Fri Jun 12 2020 sagitter <sagitter@fedoraproject.org> - 1:4.6-1
- Release 4.6

* Sat Feb 01 2020 sagitter <sagitter@fedoraproject.org> - 1:4.5-1
- Release 4.5| Epoch 1

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 3.28-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sat Dec 14 2019 Jeff Law <law@redhat.com> - 3.28-3
- Add missing #include for gcc-10

* Fri Oct 04 2019 Gwyn Ciesla <gwync@protonmail.com> - 3.28-2
- Rebuild for new freeglut

* Thu Sep 05 2019 sagitter <sagitter@fedoraproject.org> - 3.28-1
- Release 3.28

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 3.21-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue Feb 19 2019 sagitter <sagitter@fedoraproject.org> - 3.21-1
- Release 3.21

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 3.19-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Dec 13 2018 sagitter <sagitter@fedoraproject.org> - 3.19-1
- Release 3.19

* Thu Oct 18 2018 sagitter <sagitter@fedoraproject.org> - 3.16-1
- Update to 3.16

* Thu Sep 13 2018 sagitter <sagitter@fedoraproject.org> - 3.15-1
- Update to 3.15

* Sun Jul 22 2018 sagitter <sagitter@fedoraproject.org> - 3.14-2
- Force symlinks

* Sun Jul 22 2018 sagitter <sagitter@fedoraproject.org> - 3.14-1
- Update to 3.14

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Sun May 20 2018 sagitter <sagitter@fedoraproject.org> - 3.12-1
- Update to 3.12

* Sat Feb 17 2018 sagitter <sagitter@fedoraproject.org> - 3.11-1
- Update to 3.11

* Fri Feb 16 2018 sagitter <sagitter@fedoraproject.org> - 3.10-3
- Use %%%%ldconfig_scriptlets

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sat Oct 14 2017 sagitter <sagitter@fedoraproject.org> - 3.10-1
- Update to 3.10

* Sun Aug 06 2017 sagitter <sagitter@fedoraproject.org> - 3.9-1
- Update to 3.9

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.8-3
- Rebuilt for
  https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sun Jun 11 2017 sagitter <sagitter@fedoraproject.org> - 3.8-1
- Update to 3.8

* Mon May 15 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_27_Mass_Rebuild

* Wed Feb 08 2017 sagitter <sagitter@fedoraproject.org> - 3.7-1
- Update to 3.7

* Sun Feb 05 2017 sagitter <sagitter@fedoraproject.org> - 3.6-1
- Update to 3.6

* Sun Dec 25 2016 sagitter <sagitter@fedoraproject.org> - 3.5-1
- Update to 3.5

* Tue Nov 15 2016 sagitter <sagitter@fedoraproject.org> - 3.4-2
- Update to 3.4

* Tue Nov 15 2016 sagitter <sagitter@fedoraproject.org> - 3.4-1
- Update to 3.4

* Sat Oct 01 2016 sagitter <sagitter@fedoraproject.org> - 3.3-1
- Update to 3.3

* Thu Jul 07 2016 sagitter <sagitter@fedoraproject.org> - 3.2-2
- Make obj directories (strange assembler error)

* Thu Jul 07 2016 sagitter <sagitter@fedoraproject.org> - 3.2-1
- Update to 3.2

* Sun May 29 2016 sagitter <sagitter@fedoraproject.org> - 2.5-1
- Update to 2.5

* Sat Apr 09 2016 sagitter <sagitter@fedoraproject.org> - 2.4-1
- Update to 2.4

* Sat Apr 02 2016 sagitter <sagitter@fedoraproject.org> - 2.3-2
- Parallel Make disabled

* Sat Apr 02 2016 sagitter <sagitter@fedoraproject.org> - 2.3-1
- New package (bz#1318381)
## END: Generated by rpmautospec
